Bug 67259 - Add Perforce versioncontrol support to 6.X and later versions. (http://perforce.com/perforce/partners/index.html)
Add Perforce versioncontrol support to 6.X and later versions. (http://perfor...
Status: RESOLVED WONTFIX
Product: third-party
Classification: Unclassified
Component: -- Other --
6.x
All All
: P1 with 7 votes (vote)
: TBD
Assigned To: issues@third-party
issues@third-party
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2005-10-21 03:19 UTC by wqtnetbeans
Modified: 2012-10-18 14:47 UTC (History)
1 user (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description wqtnetbeans 2005-10-21 03:19:34 UTC
As in summary
Comment 1 geeth 2006-03-16 20:26:04 UTC
Although we would like to use NB 5.0 IDE, me and my team are unable to use 5.0
as there is no support for Perforce. 
Comment 2 jmwhite5 2006-11-01 07:11:03 UTC
I have been using perforce in netbeans 5.0 and now 5.5 without any issue.  What
seems to be the problem?
Comment 3 doj 2006-11-01 13:15:32 UTC
One thing worth mentioning... as shipped, the Perforce profile doesn't work with
newer Perforce servers. Specifically, there is an extra '%' character that needs
to be added to one of the commands, as recent Perforce versions need the %
character to be escaped (with another %).

Not sure the best way to handle this, but here's the original LIST_CMD:

${OSSHELL} "${P4GLOBAL} fstat ${ROOTDIR}${PS}$[? MODULE] [${MODULE}${PS}] []$[?
DIR] [${DIR}${PS}] []%1"

... and here's what's needed on more recent Perforce servers...

${OSSHELL} "${P4GLOBAL} fstat ${ROOTDIR}${PS}$[? MODULE] [${MODULE}${PS}] []$[?
DIR] [${DIR}${PS}] []%%1"   <--- notice the extra %
Comment 4 wqtnetbeans 2006-11-01 17:23:27 UTC
jmwhite5,

The problem is that it's not a good enough plugin to use. By "good enough", I
mean the same kind of version control manangement as in what CVS is supported in
post 5.0 releases. Alternatively, if you've ever worked with the Perforce plugin
for IntelliJ IDEA or Eclipse, you'd know what I am talking about.

Comment 5 bouteill 2006-11-01 18:08:13 UTC
I'm not sure if it's related to this % escape issue, but it's not been working
for me either. All my files show as [Local] [r/o] and there's no menu option to
edit the them...
I'm using the NetBeans 5.5 GA + P4D/LINUX26X86/2006.1/102189.
It seems many other users have the same issue:
http://www.velocityreviews.com/forums/t366065-netbeans-50-amp-perforce-versioning-manager.html
Comment 6 doj 2006-11-01 19:55:19 UTC
To 'bouteill' - that sounds like the symptom where the extra % symbol is needed.
Here's how you can change the LIST_CMD...

Open the options/preferences screen, make sure you select 'Advanced'. Look
under: Source Creation and Management -> Version Control Settings -> Generic VCS
Profiles -> Perforce.

Edit the context commands for that profile, and add the extra % symbol to the
value for 'LIST_CMD [hidden]'. Accept the preference changes and do a Perforce
refresh from the IDE, it should correctly pull back state and revision number on
your workspace.
Comment 7 bouteill 2006-11-01 20:04:53 UTC
Ah! Did it for me, thanks doj!
Comment 8 avp 2007-11-06 08:25:11 UTC
Hi!
I use Netbeans 6.0 can I work with Perforce?
Comment 9 jmwhite5 2007-12-04 05:22:40 UTC
wqtnetbeans:

I agree with you.  I currently use the built-in netbeans perforce VCS integration in 5.5.1 to automatically "edit" files
I start changing (this is very convenient).  For everything else, I use either command line p4 or p4v for diff/merge.

This lack of basic integration with netbeans 6.0 forces me to stay behind at 5.5.1.  Too bad, 6.0 looks really cool.
Comment 10 bouteill 2008-05-18 01:04:39 UTC
There's a basic plugin for NB6.x available @ http://www.wonderly.org/netbeans/ It's not full featured but it has the
basics. It'd be nice to get an official one doing automatic check out of files on refactoring.
Comment 11 dklotz 2008-05-22 15:56:52 UTC
I had a chat with G Wonderly that I want to share with you. I got his permission to do so:

vvvvvvvv

dklotz wrote:
> First a thank you for everything you have done. I too am a java 
> developer and I stumbled upon your page when searching for a perforce 
> module to run on netbeans 6.1. http://www.wonderly.org/netbeans/ .
>
> I am going out on a limb here, but I bet you have been asked this many 
> times... Have you thought about working with the netbeans team to 
> publish your module?

What I've tried to encourage is that all the hard work that is being put into SVN integration be abstracted so that
arbitrary SCMs can be plugged in.  I've also tried to stress the frustrations with the IDE in how it deals with read
only files that I've not asked it to mess with.  I.e it tries to reformat old project XML files to be compatible with
new versions of the IDE, but doesn't prompt me to check them out so that it can do the work it wants to do.

> It has been an extremely frustrating experience
> trying to find perforce support for netbeans 6.1 and I happened to 
> stumble upon your page. Yet to be honest I haven’t put your module 
> into mainstream development use. I’ve tested it with 6.0.1 inside of a 
> virtual pc sandbox.

I use it on 5.5 and 5.5.1.  I have a bunch of other modules that I use regularly that need the JMI stuff which they
stripped out with no replacement for in 6.0.

> I think you would get much more exposure and praise (I hope) if we 
> could put your hard work somewhere within the netbeans.org framework.

I really don't have too much time to chase after things.  I tried to get some things going, but the team is always busy
with much larger things, and I have enough OS projects that I lead, that these little tools really are at the bottom of
my todo list.

> If you have the time to reply with your thoughts and or findings I 
> would greatly appreciate it.

Thanks for your note dklotz.  It's nice to know that some people are finding and using it.

G Wonderly

^^^^^^^^^

So here I am, trying to drum up support for adding his module into the fold or having a new module developed if possible.

Regards,

dklotz
Comment 12 bouteill 2008-05-22 16:30:03 UTC
Has the netbeans team tried to contact partners@perforce.com for a partnership on this? They seem eager to help (see
http://perforce.com/perforce/partners/index.html) and have worked w/ many other vendors to date (see
http://perforce.com/perforce/products/ide_table.html)
Comment 13 scwells72 2008-05-22 16:42:53 UTC
I emailed them (Perforce support) several months ago about this exact topic.  Here's the reply I was given:

"No, I'm not aware that we're developing such a Plug-In, internally.
I've linked your name to an existing request, nonetheless.

I also don't know whether any third-party is doing anything.
I'll ask people@Perforce and let you know if there is an additional info."

I never heard anything else.  Honestly, this is incredibly frustrating to me as I know that Perforce is an extremely
popular SCM tool that is well supported by the other IDEs (IDEA, Eclipse, Visual Studio, etc.), yet the support in
NetBeans 6.x is virtually non-existent, particularly if you want coherent refactorings and other meta-operations.

It was being actively worked by a few folks at Sun a few months ago.  I looked at the work-in-progress and it definitely
wasn't even close to ready for prime time...I think the developers of it didn't "get" Perforce vs. other SCMs such as
CVS, SVN, etc.  Evidently it was sent to Perforce for certification (which I assume it didn't receive) and then the
project was abandoned.  Sucks...
Comment 14 dklotz 2008-05-22 16:57:28 UTC
Given my own experience with this issue and reading the replies here, I think we must be going about this the wrong 
way. First off, I am new to the netbeans.org process so take the following with a grain of salt. 

Is this bug marked appropriately? 

Is it in the right area? 

If I understand Mr. Wonderly correctly, some of the problems stem from the underlying architecture. Perhaps we need to 
nail those problems first? Meaning, do we need to create a bug addressing a design flaw/feature that will move us in a 
direction that makes implementing a Perforce plug-in achievable?

I know...I ask a lot of questions... 

Thoughts?

-dklotz
Comment 15 tomwheeler 2008-07-15 16:18:22 UTC
I am just the messenger on this one, but someone posted to the nbdev list this morning saying that he is working on a NB
Perforce plugin:

   http://code.google.com/p/heresylabs/source/browse/trunk/p4nb
Comment 16 Ondrej Vrabec 2009-01-22 11:34:23 UTC
Please check a new version of the perforce plugin published by Gregg Wonderley at his web pages
(http://www.wonderly.org/netbeans/).
Released for 6.1+ platforms
Comment 17 Marian Mirilovic 2012-10-18 14:47:49 UTC
No plans to do that.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo